=== debian/changelog ===
openvdb (8.1.0-3build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 14 Jan 2022 11:36:36 +0000

openvdb (8.1.0-3) unstable; urgency=medium

  * Team upload.

  * d/control: libgmock-dev b-dep added

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 15 Sep 2021 22:24:55 +0200

openvdb (8.1.0-2) unstable; urgency=medium

  * Team upload.

  * d/control: add libgtest-dev to b-deps (Closes: #993628)

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 14 Sep 2021 23:20:26 +0200

openvdb (8.1.0-1) unstable; urgency=medium

  * New upstream version 8.1.0
  * d/control: Reflect SOVERSION to package version
  * d/rules: Adapt to latest cmake change
  * d/patches: Refresh patches
  * d/rules: Fix doc installation

 -- Mathieu Malaterre <malat@debian.org>  Sun, 29 Aug 2021 13:56:50 +0200
